<?php

/**
 * @file
 * Functions used to test loopback connections.
 */

/**
 * Menu Callback; Release a lock if the right conditions are met.
 */
function httprl_nonblockingtest_page() {
  // exit if
  //  The id is not set.
  //  The key is not set.
  //  The id does not start with httprl_.
  //  The key does not match the md5 of drupal_get_private_key().
  if (   empty($_GET['id'])
      || empty($_GET['key'])
      || strpos($_GET['id'], 'httprl_') !== 0
      || $_GET['key'] != md5(drupal_get_private_key())
        ) {
    httprl_fast403();
  }

  // Release the lock, echo out that the lock was cleared and exit.
  if (variable_get('lock_inc', './includes/lock.inc') !== './includes/lock.inc') {
    lock_release($_GET['id']);
  }
  else {
    httprl_lock_release($_GET['id']);
  }
  echo t('lock @id cleared', array('@id' => $_GET['id']));
  if (defined('VERSION') && substr(VERSION, 0, 1) >= 7) {
    drupal_exit();
  }
  else {
    exit;
  }
}
